<template>
    <div>
        <div class="alert notification is-info" v-if="$auth.$state.redirect">
            Você precisar logar no sistema antes de continuar para <strong>{{ $auth.$state.redirect }}</strong>
        </div>
        <section class="is-fullheight">
        <div class="container">

            <div class="column is-4 is-offset-4">
                <Notification
                    :message="error"
                    v-if="error !== ''"
                    :notification="notification"
                    :closeNotification="checkNotification"
                />

                <!-- <h3 class="title has-text-info">Login</h3> -->
                <div class="box">
                    <figure class="avatar has-text-centered">
                        <img src="~/assets/img/user.png">
                    </figure>
                    <form action="" @submit.prevent="login">
                        <b-field label="E-mail">
                            <b-input icon="user" type="email" placeholder="Email"
                                    v-model="form.email" required />
                        </b-field>

                        <b-field label="Senha">
                            <p class="control has-icons-left">
                                <b-input icon="key" type="password" placeholder="Password"
                                    v-model="form.password" required
                                    password-reveal
                                />
                                <span class="icon is-small is-left">
                                <i class="fa fa-lock"></i>
                                </span>
                            </p>
                        </b-field>
                        <div class="field">
                            <b-checkbox>
                                Lembrar senha
                            </b-checkbox>
                        </div>
                        <button class="button is-primary is-fullwidth">Login</button>
                    </form>
                </div>
                <p>
                    <nuxt-link :to="{ name: 'auth-register' }">
                        <strong>Cadastre-se</strong>
                    </nuxt-link> &nbsp;&nbsp;
                    <a href="../">Esqueceu a Senha?</a> &nbsp;&nbsp;
                </p>
            </div>
        </div>
    </section>
    </div>
</template>
<style scoped>
    .container {
        display: flex;
        min-height: 70vh;
        flex-direction: column;
    }

    .hero.is-success {
        background: #FFFFFF;
    }
    .hero .nav, .hero.is-success .nav {
        -webkit-box-shadow: none;
        box-shadow: none;
    }
    .box {
        margin-top: 100px;
    }
    .avatar {
        margin-top: -70px;
        padding-bottom: 20px;
    }
    .avatar img {
        padding: 5px;
        background: #fff;
        border-radius: 50%;
        -webkit-box-shadow: 0 2px 3px rgba(10,10,10,.1), 0 0 0 1px rgba(10,10,10,.1);
        box-shadow: 0 2px 3px rgba(10,10,10,.1), 0 0 0 1px rgba(10,10,10,.1);
        width: 100px;
        height: 100px;
    }
    input {
        font-weight: 300;
    }

    p {
        font-weight: 700;
    }
    p.subtitle {
        padding-top: 1rem;
    }
</style>

<script>
import busyOverlay from '~/components/busy-overlay'
import Notification from '~/components/Notification'
import { mapGetters, mapActions } from 'vuex'

export default {
    middleware: 'guest',

    components: {
        busyOverlay,
        Notification
    },

    data () {
        return {
            form: {
                email: '',
                password: ''
            },
            error: null,
            notification: false
        }
    },

    computed: {
        ...mapGetters({
            products: 'cart/products'
        })
    },
    methods: {

        async login () {
            try {
                this.$toast.show('Logando...')
                await this.$axios.get('/root/sanctum/csrf-cookie', {
                    headers: {
                        'content-type': 'application/json',
                        'accept': 'application/json'
                    },
                    withCredentials: true,
                }).then(async response => {
                  await this.$auth.loginWith('laravelSanctum', {
                    data: this.form
                  }).then(() => {
                      if (this.products.length > 0){
                          this.$axios.$post('/api/cart-sync', { data: { products: this.products }})
                              .then((response) => {
                                  response.data
                              }).catch(e => {
                                  console.log(e)
                              })
                      }
                      this.$toast.success('Autentição Realizada com Sucesso!')
                      this.notification = false;
                      this.$router.push($auth.$state.redirect ? $auth.$state.redirect : '/')
                    })
                })
            } catch (e) {
                if (e.response){
                    this.notification = true;
                    this.error = e.response.data.error.email
                    this.$toast.error(this.error);
                }
            }

        },

        checkNotification(){
            this.notification = !this.notification;

        }
    }
}
</script>
